---
title: "v2.4.0 - VoNR Implemented But Not Tested"
date: 2021-12-11 22:27:00 +0900
categories:
  - Release
tags:
  - News
  - Release
head_inline: "<style> ul { padding-bottom: 1em; } .blue { color: blue; }</style>"
---

#### New Feature
- VoNR added ([0fb8279](https://github.com/open5gs/open5gs/commit/0fb8279e3665d722d750b8e154fe34ad19905f76))

#### Security
- fix the buffer overflow ([CVE-2021-41794](https://nvd.nist.gov/vuln/detail/CVE-2021-41794))

#### Modification
- [MME] Change CAUSE(11) in Attach reject for foreign IMSI ([#1281](https://github.com/open5gs/open5gs/pull/1281)) -- [kbarlee](https://github.com/kbarlee)
- [AMF] Added AMF-initiated AM Policy Termination ([a5a5c42](https://github.com/open5gs/open5gs/commit/a5a5c424c1b99eca8147ea8532dc957b24affb1c))
- [IPv6] Change Address from fe80::X@lo to fd69:f21d:873c:fa::X ([#1250](https://github.com/open5gs/open5gs/issues/1250)) -- [rupeshmore470](https://github.com/rupeshmore470)
- [UPF] Remove ogs_link_local_addr_by_dev() ([#1217](https://github.com/open5gs/open5gs/issues/1217)) -- [shuimoshusheng](https://github.com/shuimoshusheng)
- [WebUI] Now, WebUI uses localhost by default ([#764](https://github.com/open5gs/open5gs/issues/764), [#587](https://github.com/open5gs/open5gs/pull/587))

#### Bug Fixes
- [SMF] Fix the crash when PDU setup/release interact ([#1280](https://github.com/open5gs/open5gs/issues/1280)) -- [micjerry](https://github.com/micjerry)
- [MME] Before removing enb_ue, all timers must be stopped to prevent retransmission of NAS message ([#1275](https://github.com/open5gs/open5gs/issues/1275)) -- [mmonka](https://github.com/mmonka)
- [MME] fix the crash when PDN mismatch between UE and HSS ([#1263](https://github.com/open5gs/open5gs/issues/1263)) -- [kbarlee](https://github.com/kbarlee)
- [BSF] Fix the BSF bug when two PDU session release ([#1272](https://github.com/open5gs/open5gs/pull/1272)) -- [DendoD96](https://github.com/DendoD96)
- [AMF/MME] Fix the crash during Reset message ([#1268](https://github.com/open5gs/open5gs/issues/1268)) -- [micjerry](https://github.com/micjerry)
- [5GC] Fix the race condition between UE/Network-triggered Service Request ([#1226](https://github.com/open5gs/open5gs/issues/1226)) -- [micjerry](https://github.com/micjerry)
- [AMF] To avoid GTP error indication, UPF should be deactivated ([#1238](https://github.com/open5gs/open5gs/issues/1238)) -- [rupeshmore470](https://github.com/rupeshmore470)
- [AMF] Null pointer dereference - n2InfoContent->ngap_ie_type ([#1247](https://github.com/open5gs/open5gs/issues/1247)) -- [leommxj](https://github.com/leommxj)
- [AMF] Memory corruption - Overflow num_of_part in SBI message ([#1247](https://github.com/open5gs/open5gs/issues/1247)) -- [leommxj](https://github.com/leommxj)
- [AMF/MME] We should stop timer for InitialContextSetupFailure ([#1242](https://github.com/open5gs/open5gs/issues/1242)) -- [micjerry](https://github.com/micjerry)
- [MME] This bug occurs when SGW-C restarts and the next GTP signal occurs between MME and SGW-C ([#1205](https://github.com/open5gs/open5gs/issues/1205)) -- [cecrevier](https://github.com/cecrevier)
- [MME] In Authentication-EMM State and eNB-disconnected, MME could be crashed ([#1205](https://github.com/open5gs/open5gs/issues/1205)) -- [cecrevier](https://github.com/cecrevier)
- [DBCTL] Add skipped space before $DB_URI ([#1218](https://github.com/open5gs/open5gs/pull/1218)) -- [EugeneBogush](https://github.com/EugeneBogush)
- [GTP/PFCP] Add explicit 3GPP paragraph name as comments at generation time ([#1215](https://github.com/open5gs/open5gs/pull/1215)) -- [cbalint13](https://github.com/cbalint13)
- [Meson] 0.60 build error since target has a path segment like ../dict_dcca_3gpp ([#1213](https://github.com/open5gs/open5gs/issues/1213)) -- [osmith42](https://github.com/osmith42)
- [SGW-C] Fix Create Bearer Request - Use instance 2 instead of 1 ([#1201](https://github.com/open5gs/open5gs/issues/1201), [#1212](https://github.com/open5gs/open5gs/pull/1212)) -- [cbalint13](https://github.com/cbalint13), [cbrasho](https://github.com/cbrasho)
- [AMF] Fix the crash when long MSIN length ([#1206](https://github.com/open5gs/open5gs/issues/1206)) -- [yblog123](https://github.com/yblog123)

Download -- [v2.4.0.tar.gz](https://github.com/open5gs/open5gs/archive/v2.4.0.tar.gz)
{: .notice--info}
